
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Units_of_measureDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const units_of_measure = await db.units_of_measure.create(
            {
                id: data.id || undefined,
        
        uom_name: data.uom_name
        ||
        null
            ,
            
        uom_code: data.uom_code
        ||
        null
            ,
            
        uom_type: data.uom_type
        ||
        null
            ,
            
        base_multiplier: data.base_multiplier
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return units_of_measure;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const units_of_measureData = data.map((item, index) => ({
                id: item.id || undefined,
                
                uom_name: item.uom_name
            ||
            null
            ,
            
                uom_code: item.uom_code
            ||
            null
            ,
            
                uom_type: item.uom_type
            ||
            null
            ,
            
                base_multiplier: item.base_multiplier
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const units_of_measure = await db.units_of_measure.bulkCreate(units_of_measureData, { transaction });

        // For each item created, replace relation files
        

        return units_of_measure;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const units_of_measure = await db.units_of_measure.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.uom_name !== undefined) updatePayload.uom_name = data.uom_name;
        
        
        if (data.uom_code !== undefined) updatePayload.uom_code = data.uom_code;
        
        
        if (data.uom_type !== undefined) updatePayload.uom_type = data.uom_type;
        
        
        if (data.base_multiplier !== undefined) updatePayload.base_multiplier = data.base_multiplier;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await units_of_measure.update(updatePayload, {transaction});

        
        

        
        

        

        return units_of_measure;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const units_of_measure = await db.units_of_measure.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of units_of_measure) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of units_of_measure) {
                await record.destroy({transaction});
            }
        });


        return units_of_measure;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const units_of_measure = await db.units_of_measure.findByPk(id, options);

        await units_of_measure.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await units_of_measure.destroy({
            transaction
        });

        return units_of_measure;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const units_of_measure = await db.units_of_measure.findOne(
            { where },
            { transaction },
        );

        if (!units_of_measure) {
            return units_of_measure;
        }

        const output = units_of_measure.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        output.materials_default_uom = await units_of_measure.getMaterials_default_uom({
            transaction
        });
        
        
        
        
        output.bom_lines_uom = await units_of_measure.getBom_lines_uom({
            transaction
        });
        
        
        
        
        
        
        
        
        
        output.production_orders_uom = await units_of_measure.getProduction_orders_uom({
            transaction
        });
        
        
        
        output.inventory_lots_uom = await units_of_measure.getInventory_lots_uom({
            transaction
        });
        
        
        output.inventory_transactions_uom = await units_of_measure.getInventory_transactions_uom({
            transaction
        });
        
        
        
        output.purchase_order_lines_uom = await units_of_measure.getPurchase_order_lines_uom({
            transaction
        });
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.uom_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'units_of_measure',
                        'uom_name',
                        filter.uom_name,
                    ),
                };
            }
            
            if (filter.uom_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'units_of_measure',
                        'uom_code',
                        filter.uom_code,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'units_of_measure',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.base_multiplierRange) {
                const [start, end] = filter.base_multiplierRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    base_multiplier: {
                    ...where.base_multiplier,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    base_multiplier: {
                    ...where.base_multiplier,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.uom_type) {
                where = {
                    ...where,
                uom_type: filter.uom_type,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.units_of_measure.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'units_of_measure',
                        'uom_code',
                        query,
                    ),
                ],
            };
        }

        const records = await db.units_of_measure.findAll({
            attributes: [ 'id', 'uom_code' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['uom_code', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.uom_code,
        }));
    }

    
};

